Bug 465392 - race condition in XIM handling
race condition in XIM handling
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: scim (Show other bugs)
10
All Linux
medium Severity medium
: ---
: ---
Assigned To: Peng Huang
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-02 23:38 EDT by Akira TAGOH
Modified: 2009-12-18 01:29 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 01:29:18 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Akira TAGOH 2008-10-02 23:38:45 EDT
Description of problem:
if one sends the key event to SCIM too much and too faster, the application, such as emacs and xterm freezes.

Version-Release number of selected component (if applicable):
scim-1.4.7-32.fc10

How reproducible:
always as long as it's on the above condition

Steps to Reproduce:
1.change the keyboard repeat setting to make this easier to see, like gconftool-2 -s -t int /desktop/gnome/peripherals/keyboard/delay 100 and gconftool-2 -s -t int /desktop/gnome/peripherals/keyboard/rate 110
2.open xterm with XMODIFIERS=@im=SCIM
3.keep pressing a key until it freezes
  
Actual results:
freeze

Expected results:
should handles it properly

Additional info:
What exactly happened on this race condition issue is: https://bugzilla.redhat.com/show_bug.cgi?id=452849#c19

Quote from XIM specification:
In on-demand-synchronous method, the IM library always receives XIM_FORWARD_EVENT or XIM_COMMIT message as a synchronous request. Also, the IM Server needs to synchronously process the correspondent reply from the IM library and the following XIM_FORWARD_EVENT message sent from the IM library when any of the event causes the IM Server to send XIM_FORWARD_EVENT or XIM_COMMIT message to the IM library, so that the input service is consistent.  If the IM library gets the control back from the application after receiving the synchronous request, the IM library replies for the synchronous request before processing any of the events. In this time, the IM Server blocks XIM_FORWARD_EVENT message which is sent by the IM library, and handles it after receiving the reply. Howerver, the IM Server handles the other protocols /at any time/.

So in the case at the above URL, XIM server has to process XIM_SET_IC_VALUES regardless of waiting for XIM_SYNC_REPLY.
Comment 1 Bug Zapper 2008-11-25 22:29:28 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bug Zapper 2009-11-18 03:30:02 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Bug Zapper 2009-12-18 01:29:18 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.